#include 	<avr/io.h>
#include 	<avr/interrupt.h>
#include 	<avr/signal.h>
#include 	<util/delay.h>
#include 	<stdlib.h>
#include 	<stdio.h>
#include 	<string.h>

#include 	"lcd.h"
//----------------------------------------------------------------------------------//
#define		TINY_DDR	DDRB
#define		TINY_PORT	PORTB
#define		LED1		PB4
//----------------------------------------------------------------------------------//
#define 	ADC_VREF_TYPE 0x20 
//----------------------------------------------------------------------------------//
void init_adc (void)
{
		ADMUX	=	ADC_VREF_TYPE & 0xff; 
		ADCSRA	=	0xA6; 
		ADCSRB	&=	0x58; 
}
//----------------------------------------------------------------------------------//
unsigned char Read_adc(unsigned char adc_input) 
{ 
	
		ADMUX=adc_input | (ADC_VREF_TYPE & 0xff); 
		_delay_us(10);
	 
		ADCSRA	|=	0x40; 
		while 	((ADCSRA & 0x10)==0);
		ADCSRA	|=	0x10;
		 
	return 	ADCH; 
} 
//----------------------------------------------------------------------------------//
int main (void)
{
	unsigned int 	adc;
	unsigned char 	lcd_buf[17],i;

	DDRB = 0xFF;		//and all output

	DDRB &= ~_BV(PB3);	////PB4 input 

	_delay_ms (5);

	sei ();

	init_adc ();

	init_lcd ();

	lcd_gotoxy (1,1);

	lcd_printf ("ATtiny25 Testing",DSPL_LEFT);
	lcd_gotoxy (1,2);

	while (1)
	{
		TINY_PORT	^= 	_BV(LED1);
		
		adc = Read_adc (3);
		memset  (lcd_buf, ' ', sizeof lcd_buf-1);

		adc = adc / 16;
			adc += 1;
		lcd_gotoxy (1,2);
		for (i = 0; i < adc; i++)
			lcd_buf[i] = 0xff;
		lcd_buf[17] = 0;
		lcd_printf (lcd_buf, DSPL_LEFT);
		_delay_ms (1000);
			
	}
	return 1;
}
